
/****************************************************************/
/* WARNING this file is automatically generated DO NOT EDIT IT! */
/*                                                              */
/* This file provides an interface between eTPU code and CPU    */
/* code. All references to the CRANK function should be made   */
/* with information in this file. This allows only symbolic     */
/* information to be referenced which allows the eTPU code to be*/
/* optimized without effecting the CPU code.                    */
/****************************************************************/
#ifndef _ETPU_CRANK_AUTO_H_
#define _ETPU_CRANK_AUTO_H_

/****************************************************************
* Function Configuration Information.
****************************************************************/
#define FS_ETPU_CRANK_FUNCTION_NUMBER  1 
#define FS_ETPU_CRANK_TABLE_SELECT    1 
#define FS_ETPU_CRANK_NUM_PARMS       0x0060 

/****************************************************************
* Host Service Request Definitions.
****************************************************************/
#define FS_ETPU_CRANK_INIT        7 
#define FS_ETPU_CRANK_ANGLE_ADJUST             1
#define FS_ETPU_CRANK_IPH              3

/****************************************************************
* Parameter Definitions.
****************************************************************/
#define FS_ETPU_CRANK_SIGNED_ANGLE_ADJUST_OFFSET            0x002D
#define FS_ETPU_CRANK_TICKS_PER_TOOTH_OFFSET                0x0005
#define FS_ETPU_CRANK_ERROR_STATUS_OFFSET                   0x0008
#define FS_ETPU_CRANK_TOOTH_COUNT_OFFSET                    0x0000
#define FS_ETPU_CRANK_TOOTH_TIME_OFFSET                     0x0001
#define FS_ETPU_CRANK_PHYSICAL_CRANK_TEETH_OFFSET           0x0004
#define FS_ETPU_CRANK_WINDOWING_RATIO_AFTER_GAP_OFFSET      0x0011
#define FS_ETPU_CRANK_WINDOWING_RATIO_NORMAL_OFFSET         0x0009
#define FS_ETPU_CRANK_WINDOWING_RATIO_ACROSS_GAP_OFFSET     0x000D
#define FS_ETPU_CRANK_WINDOWING_RATIO_TIMEOUT_OFFSET        0x0015
#define FS_ETPU_CRANK_MISSING_TOOTH_COUNT_OFFSET            0x000C
#define FS_ETPU_CRANK_BLANK_TOOTH_COUNT_OFFSET              0x0010
#define FS_ETPU_CRANK_BLANK_TIME_OFFSET                     0x001D
#define FS_ETPU_CRANK_FIRST_TOOTH_TIMEOUT_OFFSET            0x0025
#define FS_ETPU_CRANK_HOST_ASSERTED_TOOTH_COUNT_OFFSET      0x0014
#define FS_ETPU_CRANK_GAP_RATIO_OFFSET                      0x0019
#define FS_ETPU_CRANK_ANGLE_START_COUNT_OFFSET              0x0029
#define FS_ETPU_CRANK_BLANK_TIME_EXPIRED_FLAG_OFFSET        0x0018
#define FS_ETPU_CRANK_MISSING_TOOTH_COUNT_MASK_OFFSET       0x0031
#define FS_ETPU_CRANK_STATE_OFFSET                          0x001C
#define FS_ETPU_CRANK_TOOTH_PERIOD_A_OFFSET                 0x0045
#define FS_ETPU_CRANK_CAM_STATE_OFFSET                      0x0021
#define FS_ETPU_CRANK_LINK_1_OFFSET                         0x0034
#define FS_ETPU_CRANK_LINK_2_OFFSET                         0x0038
#define FS_ETPU_CRANK_LINK_3_OFFSET                         0x003C
#define FS_ETPU_CRANK_LINK_4_OFFSET                         0x0040
#define FS_ETPU_CRANK_TOOTH_ANGLE_TARGET_OFFSET   0x0049

/* crank_edge_polarity options */
#define FS_ETPU_CRANK_FM0_RISING_EDGE  1 
#define FS_ETPU_CRANK_FM0_FALLING_EDGE 0 

/* crank_priority options ; required for GCT */
#define FS_ETPU_CRANK_PRIORITY_DISABLE  FS_ETPU_PRIORITY_DISABLE  /* Disable */
#define FS_ETPU_CRANK_PRIORITY_HIGH     FS_ETPU_PRIORITY_HIGH     /* High*/
#define FS_ETPU_CRANK_PRIORITY_MIDDLE   FS_ETPU_PRIORITY_MIDDLE   /* Middle*/
#define FS_ETPU_CRANK_PRIORITY_LOW      FS_ETPU_PRIORITY_LOW      /* Low*/

/* Error codes */
#define FS_ETPU_CRANK_NO_ERROR    0 
#define FS_ETPU_CRANK_INVALID_M1  1 
#define FS_ETPU_CRANK_INVALID_M2  2 
#define FS_ETPU_CRANK_TIMEOUT     4 
#define FS_ETPU_CRANK_STALL       8 
#define FS_ETPU_CRANK_INTERNAL_ERROR     16 

/* Crank states */
#define FS_ETPU_CRANK_SEEK              0
#define FS_ETPU_CRANK_BLANK_TIME        1
#define FS_ETPU_CRANK_BLANK_TEETH       2
#define FS_ETPU_CRANK_FIRST_EDGE        3
#define FS_ETPU_CRANK_SECOND_EDGE       4
#define FS_ETPU_CRANK_TEST_POSSIBLE_GAP 5
#define FS_ETPU_CRANK_VERIFY_GAP        6
#define FS_ETPU_CRANK_GAP_VERIFIED      7
#define FS_ETPU_CRANK_COUNTING          8
#define FS_ETPU_CRANK_TOOTH_BEFORE_GAP  9
#define FS_ETPU_CRANK_TOOTH_AFTER_GAP   10
#define FS_ETPU_CRANK_TOOTH_AFTER_GAP_NOT_HRM   11

/* System Sync States */
#define FS_ETPU_ENG_POS_SEEK             0
#define FS_ETPU_ENG_POS_FIRST_HALF_SYNC  1
#define FS_ETPU_ENG_POS_PRE_FULL_SYNC    2
#define FS_ETPU_ENG_POS_FULL_SYNC        3
#define FS_ETPU_ENG_POS_HALF_SYNC        4

/* Global variables : shared between functions */
#define FS_ETPU_ENG_POS_SYNC_STATUS_GLOBAL_OFFSET             0x0005

#endif
